import random
import math
random.seed("personal05/stones")

class TestGen:
    def __init__(self):
        self.test_number = 0
        self.subtask = ""
        self.desc_file = open("../tests.desc", "w")

    def generate_samples(self):             
        self.print_test(5, [2, 3, 4], "sample 1", 0, "preliminary")
        self.print_test(7, [2, 3, 4], "sample 2", 0, "preliminary")

    def generate_random_test(self, maxn, mustExists=False):
        n = maxn
        jump = 2
        if (random.randint(1, 3) == 1) and (not mustExists): #no answer
            jump = 3
        stones = []
        stone = 0
        while stone < n:
            next_stone = random.randint(stone + 1, stone + jump)
            if next_stone < n:
                stones.append(next_stone)
            stone = next_stone
        self.print_test(n, stones, "random test: n = %d" % n)

    def generate_first_group_of_tests(self, folder):
        self.subtask = folder
        self.print_test(1, [], "min test: n = 1, no stones")
        self.print_test(2, [], "min test: n = 2, no stones")
        self.print_test(2, [1], "min test: n = 2, stones = [1]")
        self.print_test(3, [], "min test: n = 3, no stones")
        self.print_test(3, [1], "min test: n = 3, stones = [1]")
        self.print_test(3, [2], "min test: n = 3, stones = [2]")
        self.print_test(4, [2, 3], "min test: n = 4, stones = [2, 3]")
        self.print_test(4, [1, 2, 3], "min test: n = 4, stones = [1, 2, 3]")
        ns = [5, 10, 25, 100, 1000]
        for n in ns:
            for i in range(3):
                self.generate_random_test(n)
        maxn = 1000
        x = random.randint(1, maxn)
        stones = [i for i in range(1, x)]
        stones.extend([i for i in range(x + 1, maxn)])
        self.print_test(maxn, stones, "max test: n = %d, stones contain only one hole" % maxn)

        maxn = 1000
        x = random.randint(1, maxn)
        stones = [i for i in range(1, x)]
        stones.extend([i for i in range(x + 2, maxn)])
        self.print_test(maxn, stones, "max test: n = %d, stones contain two consecutive holes" % maxn)

    def generate_second_group_of_tests(self, folder):
        self.subtask = folder
        self.print_test(1, [], "min test: n = 1, no stones")
        self.print_test(2, [], "min test: n = 2, no stones")
        self.print_test(2, [1], "min test: n = 2, stones = [1]")
        self.print_test(3, [1], "min test: n = 3, stones = [1]")
        self.print_test(3, [2], "min test: n = 3, stones = [2]")
        self.print_test(4, [2, 3], "min test: n = 4, stones = [2, 3]")
        self.print_test(4, [1, 2, 3], "min test: n = 4, stones = [1, 2, 3]")
        ns = [5, 10, 25, 100, 1000, 10**5]
        for n in ns:
            for i in range(3):
                self.generate_random_test(n, True)

        maxn = 10**5
        x = random.randint(1, maxn)
        stones = [i for i in range(1, x)]
        stones.extend([i for i in range(x + 1, maxn)])
        self.print_test(maxn, stones, "max test: n = %d, stones contain only one hole" % maxn)

        maxn = 10**5
        x = maxn - 2
        stones = [i for i in range(1, x)]
        stones.extend([i for i in range(x + 1, maxn)])
        self.print_test(maxn, stones, "max test: n = %d, stones contain only one hole in the end" % maxn)

    def generate_third_group_of_tests(self, folder):
        self.subtask = folder
        self.print_test(1, [], "min test: n = 1, no stones")
        self.print_test(2, [], "min test: n = 2, no stones")
        self.print_test(2, [1], "min test: n = 2, stones = [1]")
        self.print_test(3, [], "min test: n = 3, no stones")
        self.print_test(3, [1], "min test: n = 3, stones = [1]")
        self.print_test(3, [2], "min test: n = 3, stones = [2]")
        self.print_test(4, [2, 3], "min test: n = 4, stones = [2, 3]")
        self.print_test(4, [1, 2, 3], "min test: n = 4, stones = [1, 2, 3]")
        ns = [5, 10, 25, 100, 1000, 10**5]
        for n in ns:
            for i in range(3):
                self.generate_random_test(n)
        maxn = 10**5
        x = random.randint(1, maxn)
        stones = [i for i in range(1, x)]
        stones.extend([i for i in range(x + 1, maxn)])
        self.print_test(maxn, stones, "max test: n = %d, stones contain only one hole" % maxn)

        maxn = 10**5
        x = random.randint(1, maxn)
        stones = [i for i in range(1, x)]
        stones.extend([i for i in range(x + 2, maxn)])
        self.print_test(maxn, stones, "max test: n = %d, stones contain two consecutive holes" % maxn)
               
        maxn = 10**5
        x = maxn - 2
        stones = [i for i in range(1, x)]
        stones.extend([i for i in range(x + 1, maxn)])
        self.print_test(maxn, stones, "max test: n = %d, stones contain only one hole in the end" % maxn)

        maxn = 10**5
        x = maxn - 3
        stones = [i for i in range(1, x)]
        stones.extend([i for i in range(x + 2, maxn)])
        self.print_test(maxn, stones, "max test: n = %d, stones contain two consecutive holes in the end" % maxn)

    def print_test(self, n, xs, description, points=0, folder="tests"):
        self.test_number += 1
        print("Generating test %d" % self.test_number)
        
        dirname = os.path.join('..', folder)
        test_name = os.path.join(dirname, "{0:0=2d}".format(self.test_number))
        if not os.path.exists(dirname):
            os.makedirs(dirname)
        test_file = open(test_name, "w")
        print(n, len(xs), file=test_file)
        print(' '.join(str(element) for element in xs), file=test_file)
        print(test_name + ", folder=" + folder + ", subtask=" + self.subtask + ", points=" + str(points) + ", comment=\"" + description + "\"", file=self.desc_file)
        test_file.close()

    def generate_all_tests(self):
        self.generate_samples() 
        self.test_number = 0
        
        #First group of tests
        self.generate_first_group_of_tests("subtask1")
        print("comment_subtask1=\"n &lt;= 1000\"", file=self.desc_file)
        print("bonus_subtask1=34", file=self.desc_file)
        
        #Second group of tests
        self.generate_second_group_of_tests("subtask2")
        print("comment_subtask2=\"the answer exists\"", file=self.desc_file)
        print("bonus_subtask2=35", file=self.desc_file)

        #Third group of tests
        self.generate_third_group_of_tests("subtask3")
        print("comment_subtask3=\"n &lt;= 10^5\"", file=self.desc_file)
        print("bonus_subtask3=31", file=self.desc_file)
        
        self.desc_file.close()

import os, shutil
if os.path.exists('../tests'):
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)
if os.path.exists('../preliminary'):
    shutil.rmtree('../preliminary', ignore_errors=False, onerror=None)
try:
    os.makedirs('../tests')
    os.makedirs('../preliminary')
except OSError:
    pass

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)
